SystemOrganization addCategory: #'MC2-Repositories-Directory'!
SystemOrganization addCategory: #'MC2-Repositories-File'!
SystemOrganization addCategory: #'MC2-Repositories-Network'!

MDRepository subclass: #MDDirectoryRepository
	instanceVariableNames: 'name directory primary secondary nameOfPrimary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Directory'!

!MDDirectoryRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 8/17/2008 21:42'!
named: aString
	^ self new setName: aString! !

!MDDirectoryRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2008 20:00'!
on: aDirectory
	^ self new setDirectory: aDirectory! !

!MDDirectoryRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 10/27/2008 22:36'!
type
	^ #McrDirectory! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/21/2008 20:25'!
addFileNamed: aString
	| stream |
	stream := directory oldFileNamed: aString.
	secondary add: (MDFileRepository on: stream)! !

!MDDirectoryRepository methodsFor: 'synchronization' stamp: 'cwp 8/21/2008 20:13'!
allHashstamps
	| hashstamps |
	self scanDirectory.
	hashstamps := primary allHashstamps asSet.
	secondary do: [:ea | hashstamps addAll: ea allHashstamps].
	^ hashstamps! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'jf 10/25/2008 13:30'!
close
	super close.
	primary isNil ifFalse: [primary close].
	secondary isNil ifFalse: [secondary do: [:each | each close]]! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'cwp 11/23/2008 13:13'!
createDirectory
	directory assureExistence.
	self setPrimary: (MDFileRepository on: (directory newFileNamed: self primaryFilename)).! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 13:18'!
description
	^ self name, '/', self primaryName! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'cwp 10/22/2009 12:13'!
destroy
	super destroy.
	directory recursiveDelete! !

!MDDirectoryRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:21'!
elementClass
	^ MDDirectoryRepositoryElement! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/21/2008 20:10'!
entryIsSecondary: entry 
	^ entry isDirectory not 
		and: [ (entry name endsWith: '.mcr') 
			and: [ entry name ~= primary name ] ]! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/21/2008 20:19'!
fileNames
	^ directory entries 
		inject: Set new
		into: 
			[ :set :entry | 
			(self entryIsSecondary: entry) ifTrue: [set add: entry name].
			set ].
	! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'cwp 8/21/2008 20:12'!
get: aHashstamp
	^ (primary get: aHashstamp) ifNil:
		[self scanDirectory.
		secondary do: [:ea | (ea get: aHashstamp) ifNotNilDo: [:obj | ^ obj]].
		nil]! !

!MDDirectoryRepository methodsFor: 'testing' stamp: 'cwp 4/21/2009 14:25'!
hasPrimaryName
	^ nameOfPrimary notNil! !

!MDDirectoryRepository methodsFor: 'synchronization' stamp: 'cwp 8/21/2008 20:13'!
includes: aHashstamp
	^ (primary includes: aHashstamp) or: 
		[self scanDirectory.
		secondary anySatisfy: [:ea | ea includes: aHashstamp]]! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'cwp 11/23/2008 13:08'!
initFiles
	secondary := Set new.
	directory exists 
		ifTrue: 
			[self openPrimary. 
			self scanDirectory]
		ifFalse: 
			[self createDirectory]
! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'cwp 8/21/2008 20:12'!
memos
	| memos |
	memos := primary memos.
	self scanDirectory.
	secondary do: [:ea | memos addAll: ea memos].
	^ memos! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 13:17'!
name
	^ name! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 10/18/2009 21:48'!
name: aString
	name := aString! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 11/23/2008 13:14'!
openPrimary
	| filename |
	filename := self primaryFilename.
	self setPrimary: (MDFileRepository on: (directory fileNamed: filename)). ! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 13:13'!
primaryFilename
	^ self primaryName, '.mcr'! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:21'!
primaryName
	^ nameOfPrimary ifNil:
		[MDPlatform current initials]! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:24'!
primaryName: aString
	nameOfPrimary := aString! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 15:57'!
properties: properties
	| changed |
	changed := self updateName: properties name.
	changed := changed | (self updatePrimaryName: properties primaryName).
	changed ifTrue: [self initFiles].! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'cwp 8/17/2008 22:41'!
put: anObject
	primary put: anObject! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/20/2008 22:19'!
scanDirectory
	| filenames reponames |
	filenames := self fileNames.
	reponames := secondary collect: [ :ea | ea name ].
	filenames do: [ :ea | (reponames includes: ea) ifFalse: [ self addFileNamed: ea ] ].
	secondary removeAllSuchThat: [ :ea | (filenames includes: ea name) not ]! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'cwp 8/21/2008 20:23'!
setDirectory: aDirectory 
	directory := aDirectory.
	name := aDirectory localName.
	self initFiles.
	self initId! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'cwp 8/20/2008 20:52'!
setName: aString 
	name := aString.
	directory := FileDirectory default directoryNamed: aString.
	self initFiles.
	self initId! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'jf 10/25/2008 13:28'!
setPrimary: aFileRepository
	primary isNil ifFalse: [primary close].
	primary := aFileRepository! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:17'!
update: properties
	super update: properties.
	properties primaryName: self primaryName.
	^ properties! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 15:40'!
updateName: newName
	| parent |
	name = newName ifTrue: [^ false].
	directory 
		ifNil: [parent := FileDirectory default]
		ifNotNil: 
			[self close.
			parent := directory containingDirectory.
			parent rename: name toBe: newName].
	name := newName.
	directory := parent directoryNamed: name.
	^ true! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:22'!
updatePrimaryName: aString
	nameOfPrimary = aString ifTrue: [^ false].
	nameOfPrimary := aString.
	^ true! !

MDRepository subclass: #MDFileRepository
	instanceVariableNames: 'dataStream index memos lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-File'!

!MDFileRepository class methodsFor: 'accessing' stamp: 'cwp 10/12/2005 21:30'!
extension
	^ '.mcr'! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'cwp 10/18/2009 22:19'!
id: aHashstamp name: aString
	| theName |
	theName := (aString endsWith: self extension)
		ifTrue: [aString]
		ifFalse: [aString, self extension].
	^ self basicNew
		initializeWithId: aHashstamp
		stream: (FileStream fileNamed: theName)! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'cwp 2/2/2006 22:20'!
named: aString
	^ self on: (FileStream fileNamed: aString, self extension)! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'dc 7/19/2007 10:41'!
named: aString do: aBlock
	^ self
		on: (FileStream fileNamed: aString, self extension)
		do: aBlock! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'cwp 10/22/2009 00:06'!
on: aFileStream
	^ self new
		initializeWithId: MDHashstamp new
		stream: aFileStream;
		yourself! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'cwp 10/22/2009 00:07'!
on: aFileStream do: aBlock 
	| repository |
	repository := self on: aFileStream.
	^ [ aBlock value: repository ] 
		ensure: [ repository close ]! !

!MDFileRepository class methodsFor: 'class initialization' stamp: 'cwp 10/22/2008 20:47'!
startUp
	"Do nothing. This is implemented because old versions registered
	to be notified at start up, and that registration might still be in effect."! !

!MDFileRepository class methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:49'!
type
	^ #McrFile! !

!MDFileRepository methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:22'!
= other
	^ self species = other species
		and: [other dataStreamIs: dataStream]! !

!MDFileRepository methodsFor: 'synchronization' stamp: 'cwp 12/23/2007 00:11'!
allHashstamps
	self rescanData.
	^ index keys collect: [:ea | MDHashstamp fromBytes: ea]! !

!MDFileRepository methodsFor: 'public' stamp: 'cwp 10/13/2005 23:01'!
close
	dataStream close! !

!MDFileRepository methodsFor: 'private' stamp: 'cwp 12/25/2006 15:23'!
dataStreamIs: aStream
	^ dataStream = aStream! !

!MDFileRepository methodsFor: 'public' stamp: 'cwp 10/22/2009 12:18'!
destroy
	| path |
	super destroy.
	path := dataStream stream fullName.
	FileDirectory deleteFilePath: path.! !

!MDFileRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:22'!
elementClass
	^ MDFileRepositoryElement! !

!MDFileRepository methodsFor: 'private' stamp: 'cwp 10/22/2008 20:44'!
flushIndex	
	lastPosition := 0.
	index := Dictionary new.
	memos := Set new.
	! !

!MDFileRepository methodsFor: 'public' stamp: 'cwp 10/22/2008 20:45'!
get: aHashstamp 
	| key bytes position |
	key := aHashstamp bytes.
	position := index at: key ifAbsent: [^self rescanData ifTrue: [self get: aHashstamp]].
	bytes := dataStream valueAtPosition: position.
	bytes ifNil:
		[self flushIndex.
		self rescanData.
		bytes := dataStream valueAtPosition: position].
	^ bytes ifNotNil: [MDMarshal materialize: bytes]! !

!MDFileRepository methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
hash
	^ dataStream hash! !

!MDFileRepository methodsFor: 'synchronization' stamp: 'cwp 12/23/2007 00:12'!
includes: aHashstamp
	self rescanData.
	^ index includesKey: aHashstamp bytes! !

!MDFileRepository methodsFor: 'initialize-release' stamp: 'cwp 10/22/2009 00:05'!
initializeWithId: aHashstamp stream:  aFileStream 
	id := aHashstamp.
	self setStream: aFileStream.! !

!MDFileRepository methodsFor: 'initialize-release' stamp: 'cwp 7/27/2008 14:46'!
initializeWithStream: aFileStream 
	self setStream: aFileStream.
	self initId! !

!MDFileRepository methodsFor: 'public' stamp: 'cwp 1/19/2007 20:57'!
memos
	
	self rescanData.
	^ memos! !

!MDFileRepository methodsFor: 'public' stamp: 'cwp 5/31/2008 14:43'!
name
	^ dataStream stream localName! !

!MDFileRepository methodsFor: 'public' stamp: 'dc 6/14/2007 07:18'!
put: aHashedObject
	| key value |
	key := aHashedObject hashstamp bytes.
	index at: key ifAbsent:
		[value := MDMarshal serialize: aHashedObject.
		index at: key put: dataStream nextValuePosition.
		dataStream appendKey: key value: value.
		dataStream flush]! !

!MDFileRepository methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
rescanData
	dataStream reopen.
	dataStream fromPosition: lastPosition keysValuesAndPositionsDo:  
		[:key :val :pos |
		index at: key put: pos.
		(MDMarshal isMemo:val) ifTrue:
			[memos add: (MDMarshal materialize: val)]].
	dataStream position = lastPosition
		ifTrue: [^ false]
		ifFalse: [lastPosition := dataStream position. ^ true]! !

!MDFileRepository methodsFor: 'initialize-release' stamp: 'cwp 7/27/2008 14:46'!
setStream: aFileStream 
	dataStream := MDKeyedStream on: aFileStream.
	lastPosition := 0.
	index := Dictionary new.
	memos := Set new.
	self rescanData! !

!MDFileRepository methodsFor: 'accessing' stamp: 'cwp 10/22/2009 00:04'!
updateName: newName
	| oldName |
	dataStream
		ifNil: [self initializeWithStream: (FileDirectory default fileNamed: newName)]
		ifNotNil:
			[oldName := dataStream stream localName.
			oldName = newName ifFalse: 
				[ | directory |
				directory := dataStream stream directory.
				self close.
				directory rename: oldName toBe: newName.
				self initializeWithId: id stream: (directory oldFileNamed: newName)]]! !

MDRepository subclass: #MDNetRepository
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDNetRepository class methodsFor: 'instance creation' stamp: 'cwp 1/20/2008 13:09'!
host: aString
	^ self link: (MDNetLink host: aString)! !

!MDNetRepository class methodsFor: 'instance creation' stamp: 'cwp 1/20/2008 12:27'!
host: aString port: anInteger
	^ self link: (MDNetLink host: aString port: anInteger)! !

!MDNetRepository class methodsFor: 'instance creation' stamp: 'cwp 10/18/2009 22:38'!
id: aHashstamp host: aString port: anInteger
	^ self id: aHashstamp link: (MDNetLink host: aString port: anInteger)! !

!MDNetRepository class methodsFor: 'instance creation' stamp: 'cwp 10/18/2009 22:39'!
id: aHashstamp link: aLink
	^ self basicNew intializeWithId: aHashstamp link: aLink! !

!MDNetRepository class methodsFor: 'instance creation' stamp: 'cwp 10/18/2009 22:32'!
link: aLink
	^ self id: MDHashstamp new link: aLink! !

!MDNetRepository class methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:51'!
type
	^ #Mnrp! !

!MDNetRepository methodsFor: 'synchronization' stamp: 'cwp 5/22/2008 00:11'!
allHashstamps
	| result |
	result := self send: MDGetHashstamps new.
	result assertMessageIs: MDAllHashstamps.
	^ result hashstamps! !

!MDNetRepository methodsFor: 'public' stamp: 'jf 10/25/2008 13:39'!
close
	| bye |
	link isOpen ifTrue: [
		bye := link send: MDGoodbye new.
		link close.
		bye assertMessageIs: MDGoodbye ]! !

!MDNetRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:23'!
elementClass
	^ MDNetRepositoryElement! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
get: aHashstamp
	| objects |
	objects := self getAll: (Set with: aHashstamp).
	^ objects isEmpty ifFalse: [objects anyOne]! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
getAll: aCollection
	| result |
	result := self send: (MDGetObjects with: aCollection).
	result assertMessageIs: MDObjects.
	^ result objects! !

!MDNetRepository methodsFor: 'synchronization' stamp: 'cwp 1/8/2008 18:45'!
includes: aHashstamp
	^ (self get: aHashstamp) notNil! !

!MDNetRepository methodsFor: 'initialize-release' stamp: 'cwp 10/18/2009 22:31'!
intializeWithId: aHashstamp link: aLink
	self initialize.
	id := aHashstamp.
	link := aLink.! !

!MDNetRepository methodsFor: 'accessing' stamp: 'cwp 10/21/2009 23:38'!
link: aLink
	link := aLink! !

!MDNetRepository methodsFor: 'accessing' stamp: 'cwp 1/21/2008 20:41'!
locator
	^ link locator! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
memos
	| result |
	result := self send: MDGetMemos new.
	result assertMessageIs: MDMemos.
	^ result objects! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/31/2008 14:44'!
name
	^ link description! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
put: anObject
	| result |
	result := self send: (MDPutObjects with: {anObject}). 
	result assertMessageIs: MDThankYou! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
putAll: aCollection
	| request |
	request := self send: (MDOfferObjects withObjects: aCollection).
	request assertMessageIs: MDRequestObjects.
	request 
		filter: aCollection
		in: [:put | (self send: put) assertMessageIs: MDThankYou]
! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
selectFrom: aCollection
	| request |
	request := self send: (MDOfferObjects with: aCollection).
	request assertMessageIs: MDRequestObjects.
	^ request hashstamps! !

!MDNetRepository methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
send: aMessage
	| result |
	link isOpen ifFalse:
		[link open.
		result := link send: MDHello new.
		result assertMessageIs: MDHello].
	result := link send: aMessage.
	result checkForError.
	^ result! !

!MDNetRepository methodsFor: 'private' stamp: 'cwp 5/24/2008 13:19'!
setLink: aLink
	link := aLink.
	self initId! !

!MDNetRepository methodsFor: 'accessing' stamp: 'cwp 6/5/2008 21:46'!
update: properties
	super update: properties.
	^ self locator update: properties! !

Object subclass: #MDByteIndex
	instanceVariableNames: 'keySize valueSize streamSize stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-File'!

!MDByteIndex class methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2005 03:08'!
stream: aStream keySize: keyNumber valueSize: valueNumber
	^ self stream: aStream keySize: keyNumber valueSize: valueNumber streamSize: aStream size! !

!MDByteIndex class methodsFor: 'as yet unclassified' stamp: 'avi 3/19/2005 02:41'!
stream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber
	^ self basicNew setStream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:36'!
at: keyArray
	^ self at: keyArray ifAbsent: [self error: 'Could not find key ', keyArray printString]! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:36'!
at: keyArray ifAbsent: errorBlock
	keyArray size = keySize ifFalse: [self error: 'Key must be exactly ', keySize asString, ' bytes'].
	^ self basicAt: keyArray ifAbsent: errorBlock! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:37'!
at: keyArray put: valueArray
	keyArray size = keySize ifFalse: [self error: 'Key must be exactly ', keySize asString, ' bytes'].
	valueArray size = valueSize ifFalse: [self error: 'Value must be exactly ', valueSize asString, ' bytes'].
	^ self basicAt: keyArray put: valueArray! !

!MDByteIndex methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
basicAt: keyArray ifAbsent: errorBlock
	| i key |
	i := self scanFor: keyArray.
	key := self keyBytesAtIndex: i.
	^ key = keyArray
		ifTrue: [self valueBytesAtIndex: i]
		ifFalse: errorBlock! !

!MDByteIndex methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
basicAt: keyArray put: valueArray
	| i key |
	i := self scanFor: keyArray.
	key := self keyBytesAtIndex: i.
	key = keyArray ifFalse:
		[self writeTally: self tally + 1.
		self writeKeyBytes: keyArray atIndex: i].
	self writeValueBytes: valueArray atIndex: i.
	^ valueArray! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:45'!
hash: keyArray
	^ keyArray hash! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/15/2005 03:38'!
keyBytesAtIndex: i
	self seekTo: i.
	^ stream atEnd
		ifTrue: [ByteArray new: keySize]
		ifFalse: [stream next: keySize]! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:05'!
keySize
	^ keySize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/15/2005 03:07'!
maxIndex
	^ streamSize - 4 // self recordSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:43'!
recordSize
	^ keySize + valueSize! !

!MDByteIndex methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
scanFor: keyArray
	| start |
	start := (self hash: keyArray) \\ self maxIndex.
	start to: self maxIndex do: [:i | (self scanFor: keyArray at: i) ifTrue: [^ i]].
	0 to: start - 1 do: [:i | (self scanFor: keyArray at: i) ifTrue: [^ i]].
	
	self error: 'Index is full'! !

!MDByteIndex methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
scanFor: keyArray at: i
	| key |
	key := self keyBytesAtIndex: i.
	^ key = keyArray or: [key allSatisfy: [:b | b = 0]]! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
seekTo: i
	stream position: i * self recordSize + 4! !

!MDByteIndex methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:11'!
setStream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber
	keySize := keyNumber.
	valueSize := valueNumber.
	streamSize := streamNumber.
	stream := aStream.
	stream binary! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/19/2005 02:51'!
streamSize
	^ streamSize! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/15/2005 03:23'!
tally
	stream reset.
	^ stream atEnd
		ifTrue: [0]
		ifFalse: [stream nextInt32]! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:41'!
valueBytesAtIndex: i
	self seekTo: i.
	stream skip: keySize.
	^ stream next: valueSize! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:05'!
valueSize
	^ valueSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:40'!
writeKeyBytes: keyBytes atIndex: i
	self seekTo: i.
	stream nextPutAll: keyBytes! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
writeTally: aNumber
	stream reset.
	stream nextInt32Put: aNumber! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:40'!
writeValueBytes: valueBytes atIndex: i
	self seekTo: i.
	stream skip: keySize.
	stream nextPutAll: valueBytes! !

Object subclass: #MDKeyedStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-File'!

!MDKeyedStream class methodsFor: 'as yet unclassified' stamp: 'avi 4/17/2005 01:19'!
on: aStream
	^ self basicNew initializeWithStream: aStream! !

!MDKeyedStream methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
= other
	^ self species = other species
		and: [self stream name = other stream name]! !

!MDKeyedStream methodsFor: 'public' stamp: 'cwp 11/6/2007 22:52'!
appendKey: keyBytes value: valueBytes 
	self assert: [keyBytes size = self keySize].
	stream
		setToEnd;
		nextPutAll: keyBytes;
		nextInt32Put: valueBytes size;
		nextPutAll: valueBytes! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 10/13/2005 23:00'!
close
	stream name = 'a stream' ifFalse: [stream close]! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:58'!
flush
	stream flush! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/19/2005 01:49'!
fromPosition: aNumber keysValuesAndPositionsDo: aBlock 
	| position key |
	stream position: aNumber.
	[stream atEnd] whileFalse: 
			[key := stream next: self keySize.
			position := stream position.
			aBlock
				value: key
				value: self readValue
				value: position]! !

!MDKeyedStream methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
hash
	^ self stream name hash! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:11'!
initializeWithStream: aPositionableStream
	stream := aPositionableStream.
	stream binary! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 4/10/2005 15:14'!
keySize
	^ 24! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 02:11'!
keysValuesAndPositionsDo: aBlock 
	self fromPosition: 0 keysValuesAndPositionsDo: aBlock
			! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:38'!
nextValuePosition
	^ stream size + self keySize! !

!MDKeyedStream methodsFor: 'public' stamp: 'cwp 4/10/2005 17:29'!
position
	^ stream position! !

!MDKeyedStream methodsFor: 'private' stamp: 'cwp 10/22/2008 20:44'!
readValue
	| length |
	[length := stream nextInt32]
		on: Error
		do: [:error | ^ nil].
	^ stream next: length.
	! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'avi 3/22/2006 19:23'!
reopen
	stream name = 'a stream' ifFalse: [stream reopen; binary]! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 4/10/2005 14:53'!
stream
	^ stream! !

!MDKeyedStream methodsFor: 'public' stamp: 'cwp 10/31/2008 23:49'!
valueAtPosition: anInteger
	[stream position: anInteger]
		on: Error
		do: [:err | ^ nil].
	^ self readValue! !

Object subclass: #MDNetLink
	instanceVariableNames: 'locator stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 13:09'!
host: aString
	^ self locator: (MDNetLocator host: aString)! !

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:40'!
host: aString port: anInteger
	^ self locator: (MDNetLocator host: aString port: anInteger)! !

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2008 14:49'!
locator: aLocator
	^ self new setLocator: aLocator! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 12:38'!
close
	stream close.
	! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:04'!
description
	^ locator description! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:10'!
isOpen
	^ stream notNil and: [stream isConnected]! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2008 16:03'!
locator
	^ locator! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
open
	stream := locator createStream.
	! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:44'!
send: aMessage
	self isOpen ifFalse: [self error: 'Link is not open'].
	aMessage writeOn: stream.
	stream flush.
	^ MDNetMessage readFrom: stream! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setLocator: aLocator
	locator := aLocator! !

Object subclass: #MDNetListener
	instanceVariableNames: 'repository port socket process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDNetListener class methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
repository: aRepository startOn: anInteger
	| listener |
	listener := self new setRepository: aRepository port: anInteger.
	listener start.
	^ listener! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:23'!
name
	^ '[', repository description, ']'! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
run
	| connection |
	[socket isValid] whileTrue:
		[connection := socket waitForAcceptFor: 10 ifTimedOut: [nil].
		connection ifNotNil: [MDServerLink 
								serve: connection 
								repository: repository]]
			! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setRepository: aRepository port: anInteger
	repository := aRepository.
	port := anInteger.
	! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
start
	socket := Socket newTCP.
	socket listenOn: port backlogSize: 10.
	process := [self run] 
				forkAt: Processor systemBackgroundPriority  
				named: self name
	! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:09'!
stop
	socket closeAndDestroy! !

Object subclass: #MDNetLocator
	instanceVariableNames: 'host port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDNetLocator class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:31'!
host: aString 
	^ self host: aString port: nil! !

!MDNetLocator class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:29'!
host: aString port: anInteger
	^ self new setHost: aString port: anInteger! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
createStream
	| class stream |
	class := Smalltalk at: #FastSocketStream ifAbsent: [Smalltalk at: #SocketStream].
	stream := class openConnectionToHostNamed: self host port: self port.
	stream binary.
	^ stream! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
defaultPort
	^ 6101! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
description
	^ String streamContents: 
		[:stream |
		stream nextPutAll: host.
		port ifNotNil:
			[stream 
				nextPut: $:; 
				print: port]]! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
host
	^ host! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
port
	^ port ifNil: [self defaultPort]! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setHost: aString port: anInteger
	host := aString.
	port := anInteger! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 6/5/2008 21:43'!
update: properties
	^ properties
		host: self host;
		port: self port;
		yourself! !

Object subclass: #MDNetMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

MDNetMessage subclass: #MDEmptyMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDEmptyMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:05'!
readContentsFrom: aStream
	^ self new! !

!MDEmptyMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:04'!
= other
	^ self species = other species! !

!MDEmptyMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:04'!
hash
	^ self species hash! !

MDEmptyMessage subclass: #MDGetHashstamps
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDGetHashstamps class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:02'!
id
	^ 68! !

!MDGetHashstamps methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:42'!
handledBy: anObject
	^ anObject handleGetHashstamps: self! !

MDEmptyMessage subclass: #MDGetMemos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDGetMemos class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 67! !

!MDGetMemos methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:11'!
handledBy: anObject
	^ anObject handleGetMemos: self! !

MDNetMessage subclass: #MDErrorMessage
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

MDErrorMessage subclass: #MDAuthenticationFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDAuthenticationFailed class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:30'!
id
	^ 193! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:26'!
= other
	^ self species = other species and: [self description = other description]! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:54'!
checkForError
	MDPeerError signal: description! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:29'!
description
	^ description! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:27'!
hash
	^ description hash! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:53'!
isError
	^ true! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setContents: aString
	description := aString! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:28'!
writeContentsOn: aStream
	MDMarshal serialize: description on: aStream! !

MDErrorMessage subclass: #MDObjectNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDObjectNotFound class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:34'!
id
	^ 195! !

MDErrorMessage subclass: #MDProcessingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

MDErrorMessage subclass: #MDStorageFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDStorageFailed class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:34'!
id
	^ 196! !

MDErrorMessage subclass: #MDUnauthorized
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDUnauthorized class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:32'!
id
	^ 194! !

MDErrorMessage subclass: #MDUnrecognizedMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDUnrecognizedMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:27'!
id
	^ 192! !

MDNetMessage subclass: #MDHashstampMessage
	instanceVariableNames: 'hashstamps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

MDHashstampMessage subclass: #MDAllHashstamps
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDAllHashstamps class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:36'!
id
	^ 132! !

MDHashstampMessage subclass: #MDGetObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDGetObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 64! !

!MDGetObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:28'!
handledBy: aService
	^ aService handleGet: self! !

!MDHashstampMessage methodsFor: 'comparing' stamp: 'cwp 1/4/2008 00:02'!
= other
	^ self species = other species and: [self hashstamps = other hashstamps]! !

!MDHashstampMessage methodsFor: 'comparing' stamp: 'cwp 1/4/2008 00:02'!
hash
	^ hashstamps hash! !

!MDHashstampMessage methodsFor: 'accessing' stamp: 'cwp 1/4/2008 00:02'!
hashstamps
	^ hashstamps! !

!MDHashstampMessage methodsFor: 'intialize-release' stamp: 'cwp 5/22/2008 00:11'!
setContents: aCollection
	hashstamps := aCollection asSet! !

!MDHashstampMessage methodsFor: 'writing' stamp: 'cwp 1/4/2008 00:02'!
writeContentsOn: aStream
	MDMarshal serialize: hashstamps on: aStream! !

MDHashstampMessage subclass: #MDOfferObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDOfferObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 65! !

!MDOfferObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:14'!
withObjects: aCollection
	^ self with: (aCollection collect: [:ea | ea hashstamp])! !

!MDOfferObjects methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:19'!
handledBy: anObject
	^ anObject handleOfferObjects: self! !

MDHashstampMessage subclass: #MDRequestObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDRequestObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 129! !

!MDRequestObjects methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
filter: aCollection in: aBlock
	| selected |
	selected := aCollection select: [:ea | hashstamps includes: ea hashstamp].
	selected isEmpty ifFalse: [aBlock value: (MDPutObjects with: selected)]! !

!MDRequestObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:00'!
isRequestObjects
	^ true! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:04'!
fromBytes: aByteArray
	^ self readFrom: aByteArray readStream! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:15'!
id
	self subclassResponsibility! !

!MDNetMessage class methodsFor: 'testing' stamp: 'cwp 1/4/2008 00:17'!
isConcrete
	^ self class includesSelector: #id! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/4/2008 00:17'!
messageClassWithId: anInteger
	^ self allSubclasses 
		detect: [:ea | ea isConcrete and: [ea id = anInteger]]
		ifNone: [self messageIdNotFound: anInteger]! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:58'!
messageClasses
	^ self allSubclasses select: [:ea | ea class includesSelector: #id]! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:12'!
messageIdNotFound: id
	^ self error: 'Message ', id asString, ' not understood'! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:27'!
readContentsFrom: aStream
	^ self with: (MDMarshal materializeFrom: aStream)! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 5/22/2008 00:11'!
readFrom: aStream
	| class |
	class := self messageClassWithId: aStream next.
	^ class readContentsFrom: aStream! !

!MDNetMessage class methodsFor: 'instance creation' stamp: 'cwp 1/3/2008 23:23'!
with: aSet
	^ self new setContents: aSet! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 21:06'!
assertMessageIs: aClass
	(self isKindOf: aClass) ifFalse: [MDProtocolError signal]! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:05'!
bytes
	^ ByteArray streamContents: [:stream | self writeOn: stream]! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 19:54'!
checkForError
	! !

!MDNetMessage methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:15'!
id
	^ self class id! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 19:53'!
isError
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 14:17'!
isGoodbye
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:36'!
isHello
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 14:24'!
isMemos
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:39'!
isObjects
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 21:01'!
isRequestObjects
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 20:57'!
isThankYou
	^ false! !

!MDNetMessage methodsFor: 'intialize-release' stamp: 'cwp 1/3/2008 23:23'!
setContents: anObject
	self subclassResponsibility! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:32'!
writeContentsOn: aStream
	! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:08'!
writeOn: aStream
	aStream nextPut: self id.
	self writeContentsOn: aStream! !

MDNetMessage subclass: #MDObjectsMessage
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

MDObjectsMessage subclass: #MDMemos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDMemos class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:45'!
id
	^ 131! !

!MDMemos methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 14:24'!
isMemos
	^ true! !

MDObjectsMessage subclass: #MDObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:45'!
id
	^ 128! !

!MDObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 12:39'!
isObjects
	^ true! !

!MDObjectsMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 1/3/2008 23:14'!
readContentsFrom: aStream
	^ self with: (MDMarshal materializeFrom: aStream)! !

!MDObjectsMessage methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:17'!
= other
	^ self species = other species
		and: [objects = other objects]! !

!MDObjectsMessage methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:17'!
hash
	^ objects hash! !

!MDObjectsMessage methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:17'!
objects
	^ objects! !

!MDObjectsMessage methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:11'!
setContents: aCollection
	objects := aCollection asSet! !

!MDObjectsMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:08'!
writeContentsOn: aStream
	MDMarshal serialize: objects on: aStream! !

MDObjectsMessage subclass: #MDPutObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDPutObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 66! !

!MDPutObjects methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:16'!
handledBy: anObject
	^ anObject handlePutObjects: self! !

MDNetMessage subclass: #MDSalutationMessage
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

MDSalutationMessage subclass: #MDGoodbye
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDGoodbye class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:40'!
id
	^ 2! !

!MDGoodbye methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:25'!
handledBy: anObject
	^ anObject handleGoodbye: anObject! !

!MDGoodbye methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 14:17'!
isGoodbye
	^ true! !

MDSalutationMessage subclass: #MDHello
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDHello class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
id
	^ 1! !

!MDHello methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:08'!
handledBy: anObject
	^ anObject handleHello: self! !

!MDHello methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:36'!
isHello
	^ true! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
= other
	^ self species = other species and: [self description = other description]! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:32'!
defaultDescription
	^ NetNameResolver localHostName! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:30'!
description
	^ description ifNil: [self defaultDescription]! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
hash
	^ description hash! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setContents: aString
	description := aString! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:29'!
writeContentsOn: aStream
	MDMarshal serialize: self description on: aStream! !

MDNetMessage subclass: #MDThankYou
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDThankYou class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 130! !

!MDThankYou methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:52'!
= other
	^ self species = other species and: [self count = other count]! !

!MDThankYou methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:52'!
count
	^ count! !

!MDThankYou methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:52'!
hash
	^ count hash! !

!MDThankYou methodsFor: 'writing' stamp: 'cwp 1/4/2008 20:58'!
isThankYou
	^ true! !

!MDThankYou methodsFor: 'intialize-release' stamp: 'cwp 5/22/2008 00:11'!
setContents: anInteger
	count := anInteger! !

!MDThankYou methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:51'!
writeContentsOn: aStream
	MDMarshal serialize: count on: aStream! !

Object subclass: #MDNetService
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDNetService class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:22'!
for: aRepository
	^ self new setRepository: aRepository! !

!MDNetService methodsFor: 'public' stamp: 'cwp 1/19/2008 01:32'!
description
	^ repository description! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 21:27'!
handleGet: message
	^ MDObjects with: (repository getAll: message hashstamps)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/8/2008 18:43'!
handleGetHashstamps: message
	^ MDAllHashstamps with: (repository allHashstamps)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:12'!
handleGetMemos: message
	^ MDMemos with: (repository memos)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:26'!
handleGoodbye: message
	^ MDGoodbye new! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:08'!
handleHello: message
	^ MDHello new! !

!MDNetService methodsFor: 'public' stamp: 'cwp 1/4/2008 22:43'!
handleMessage: aMessage
	^ [aMessage handledBy: self]
		on: Error
		do: [:err | MDProcessingError with: err description]! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 5/22/2008 00:11'!
handleOfferObjects: message
	| wanted |
	wanted := repository selectFrom: message hashstamps.
	^ MDRequestObjects with: wanted! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:34'!
handlePutObjects: message

	^ 	[repository putAll: message objects.
		MDThankYou with: message objects size]
			on: Error
			do: [:err | MDStorageFailed with: err description]! !

!MDNetService methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:11'!
setRepository: aRepository
	repository := aRepository! !

Object subclass: #MDServerLink
	instanceVariableNames: 'stream service process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

!MDServerLink class methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
serve: aSocket repository: aRepository
	| link |
	link := self socket: aSocket repository: aRepository.
	link start! !

!MDServerLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:16'!
socket: aSocket repository: aRepository
	^ self new setSocket: aSocket repository: aRepository! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
handleMessage
	|  request response |
	[request := MDNetMessage readFrom: stream]
		on: ConnectionClosed, ConnectionTimedOut 
		do: [:exception | ^ nil].
	response := service handleMessage: request.
	response writeOn: stream.
	stream flush.
	response isGoodbye ifTrue: [stream close]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/19/2008 01:32'!
name
	^ String streamContents:
		[:out |
		out 
			nextPutAll: stream socket remoteAddress asString;
			nextPutAll: '->';
			nextPutAll: service description]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/19/2008 01:16'!
run
	[stream isConnected] whileTrue: [self handleMessage]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setSocket: aSocket repository: aRepository
	stream := self streamClass on: aSocket.
	service := MDNetService for: aRepository.
	stream binary! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
start
	process := [self run] 
				forkAt: Processor highIOPriority 
				named: self name
! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:18'!
streamClass
	^ Smalltalk at: #FastSocketStream ifAbsent: [Smalltalk at: #SocketStream]! !

Error subclass: #MDNetError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

MDNetError subclass: #MDPeerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!

MDNetError subclass: #MDProtocolError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Network'!
